package com.app.portabledeviceapplication;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.NavUtils;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.AdapterView.OnItemLongClickListener;

public class DisplayIDSortedMessagesActivity extends Activity {
	
	ArrayList<String> messagesWithIDList = new ArrayList<String>();
	ArrayList<String> senderWithIDList = new ArrayList<String>();
	ArrayList<String> timeWithIDList = new ArrayList<String>();
	ArrayList<Boolean> readWithIDList = new ArrayList<Boolean>();
	ArrayList<Bitmap> pictureWithIDList = new ArrayList<Bitmap>();
	ArrayList<Uri> pictureAddresseWithIDList = new ArrayList<Uri>();
	
	private ListView listView; 
	ChatRowAdapter IDchatAdapter; 
	private Context context = this;

	@Override
	@SuppressWarnings("unchecked")
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_display_idsorted_messages);
		
		/* Retrieve data from parent activity */
		Intent intent = getIntent(); 
		messagesWithIDList = intent.getStringArrayListExtra(MainActivity.ID_MESSAGE_ARRAY);
		senderWithIDList = intent.getStringArrayListExtra(MainActivity.ID_SENDER_ARRAY);
		timeWithIDList = intent.getStringArrayListExtra(MainActivity.ID_TIME_ARRAY);
		readWithIDList =(ArrayList<Boolean>)intent.getSerializableExtra(MainActivity.ID_READ_ARRAY);
		pictureWithIDList = (ArrayList<Bitmap>)intent.getSerializableExtra(MainActivity.ID_PICTURE_ARRAY);
		pictureAddresseWithIDList = (ArrayList<Uri>)intent.getSerializableExtra(MainActivity.ID_PICTURE_ADDRESSES_ARRAY);
		
		/* Make title of activity based on which id's it is currently showing*/
		String title = "Messages with ID ";
		Boolean firstID = true;
		ArrayList<String> currentIDs = new ArrayList<String>();
		for(int i = 0; i<messagesWithIDList.size(); i++){
			String[] ID = messagesWithIDList.get(i).split(" ");
			for(int j =0; j< ID.length; j++){
					if(ID[j].startsWith("#")){
						if(firstID){
							title = title +ID[j];
							currentIDs.add(ID[j]);
							firstID = false; 
						}else{
							for(int k = 0; k < currentIDs.size(); k++){
								if(!(currentIDs.get(k).equals(ID[j]))){
									title = title +" and "+ID[j];
									currentIDs.add(ID[j]);
								}
							}
						}
						
					}
				}
		}
		this.setTitle(title);
		IDchatAdapter = new ChatRowAdapter(context, R.layout.chat_row_layout, messagesWithIDList, pictureWithIDList, senderWithIDList, timeWithIDList, readWithIDList);
		listView = (ListView)findViewById(R.id.messagesWithID);
		listView.setAdapter(IDchatAdapter);
		/* Open picture when holding the listItem for a long time*/
		listView.setOnItemLongClickListener(new OnItemLongClickListener(){
			@Override
			public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
				if(pictureWithIDList.get(position)!=null){
					Intent intent = new Intent();
					intent.setAction(Intent.ACTION_VIEW);
					intent.setDataAndType(pictureAddresseWithIDList.get(position), "image/*");
					intent.putExtra(messagesWithIDList.get(position), pictureWithIDList.get(position));
					startActivity(intent);
				}
				return true;
			}
		});
		
		IDchatAdapter.notifyDataSetChanged();
	}
		
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.display_idsorted_messages, menu);
		return true;
	}
	
	@Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
        case android.R.id.home:
            NavUtils.navigateUpFromSameTask(this);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

}
