package com.app.portabledeviceapplication;

import android.content.Context;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.provider.MediaStore;

public class PictureHandling {
	Context context;
	public PictureHandling(Context context) {
		super();
		this.context = context;
	}
	/**
	 * Get filepath of wanted picture
	 * @param uri
	 */
	public Bitmap getPath(Uri uri) {
		 String[] projection = { MediaStore.Images.Media.DATA };
		 Cursor cursor = context.getContentResolver().query(uri, projection, null, null, null);
		 
		 int column_index = cursor.getColumnIndexOrThrow(MediaStore.Images.Media.DATA);
		 cursor.moveToFirst();
		 String filePath = cursor.getString(column_index);
		 
		 cursor.close();
		 // Convert file path into bitmap image using below line.
		 Bitmap bitmap = BitmapFactory.decodeFile(filePath);
		 
		 return bitmap; 
	 }
	 
	/**
	 * Get orientation of picture
	 * @param uri filepath
	 */
	 public int getOrientation(Uri uri){
		 
		 String[] projection = { MediaStore.Images.ImageColumns.ORIENTATION};
		 Cursor cursor = context.getContentResolver().query(uri, projection, null, null, null);
		 
		 if(cursor.getCount()!=1){
			 return -1; 
		 }
		 cursor.moveToFirst();
		 return cursor.getInt(0);
	 }

}
