package com.app.portabledeviceapplication;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class SavedCategoriesActivity extends Activity {
	
	private ArrayList<String> categoryList = new ArrayList<String>();
	private ArrayList<ArrayList<String>> contentLists = new ArrayList<ArrayList<String>>();
	/* Identifiers for data to be sent between activities*/
	public final static String EXTRA_ARRAY = "com.app.portabledeviceapplication.ARRAY";
	public final static String TO_MAIN = "com.app.portabledeviceapplication.TO_MAIN";
	public final static String CATEGORY_NAME = "com.app.portabledeviceapplication.CATEGORY_NAME";
	public final static String CURRENT_ARRAY_POSITION = "com.app.portabledeviceapplication.CURRENT_ARRAY_NAME"; 
	
	ListView listView;
	Context context = SavedCategoriesActivity.this; 
	ArrayAdapter<String> adapter;
	SaveLocally saver; 
	
	/* Request Code for startActivityForResult*/
	private static final int SELECTED_PHRASE = 0;
	private static final int ADD_NEW_CATEGORY = 1;

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_saved_categories);
		categoryList.add("Add new category");
		
		saver = new SaveLocally(this);
		saver.checkExternalMedia();
		/* Read from the SD file or raw file */
		int raw = saver.sizeOfRaw();
		long SD = saver.sizeOfSDFile("SavedPhrases.txt");
		int numberOfEntries = saver.numberOfLinesRaw();
		if(SD+numberOfEntries+1<raw){
			saver.deleteSDFile("SavedPhrases.txt");
			raw = saver.sizeOfRaw();
			SD = saver.sizeOfSDFile("SavedPhrases.txt");
			saver.readRaw(categoryList, contentLists);
			saver.addAllCategoriesToSD(categoryList);
			saver.addAllCategoryContentToSD(contentLists);
			
		}else{
			saver.readPhraseFromSDCard(categoryList, contentLists, "SavedPhrases.txt");
		}
		
		adapter = new ArrayAdapter<String>(context, R.layout.saved_row_layout, categoryList);
		listView = (ListView)findViewById(R.id.saved_categories);
		listView.setAdapter(adapter);
		
		listView.setOnItemClickListener(new OnItemClickListener(){
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id){
				int size = findSizeOfArray();
				ArrayList<String> toChild = contentLists.get(position);
				int currentCategoryPosition = position; 
				if(!(position == (size-1))){
					Intent intent = new Intent(context, SavedCategoryContentActivity.class);
					intent.putExtra(EXTRA_ARRAY, toChild);
					intent.putExtra(CATEGORY_NAME, categoryList.get(position));
					intent.putExtra(CURRENT_ARRAY_POSITION, currentCategoryPosition); 
					startActivityForResult(intent, SELECTED_PHRASE);
					}
				}
		});
		listView.setOnItemLongClickListener(new OnItemLongClickListener(){
			public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
				int size = categoryList.size();
				if(position == (size-1)){
					Intent intent = new Intent(context, NewSavedPhraseActivity.class);; 
					startActivityForResult(intent, ADD_NEW_CATEGORY);
				}
				return true;
            }
		});
		adapter.notifyDataSetChanged();
		
		
	}
	
	public void onActivityResult(int requestCode, int resultCode, Intent data){
		super.onActivityResult(requestCode, resultCode, data);
		if( resultCode == RESULT_OK){
			if(requestCode == SELECTED_PHRASE){
				/* Returning from child activity SavedCategoryContentActivity*/
				StringBuilder toSDCard = new StringBuilder();
				String returnContent;
				String newContentValue;
				Boolean addedNewContent;
				newContentValue = data.getStringExtra(SavedCategoryContentActivity.ADDED_CONTENT_VALUE); 
				returnContent = data.getStringExtra(SavedCategoryContentActivity.EXTRA_CONTENT);
				addedNewContent = data.getBooleanExtra(SavedCategoryContentActivity.ADDED_CONTENT_BOOL, false);
				if(addedNewContent){
					int categoryPosition = data.getIntExtra(SavedCategoryContentActivity.CATEGORY_POSITION, 100000);
					addContent(newContentValue, contentLists.get(categoryPosition));
					toSDCard.append(categoryPosition);
					toSDCard.append("_");
					toSDCard.append(contentLists.get(categoryPosition).size()-1);
					toSDCard.append("_");
					toSDCard.append(newContentValue);
					saver.writeToSDFile(toSDCard.toString(), "SavedPhrases.txt");
				}
				
				Intent returnIntent = new Intent(context, MainActivity.class);
				returnIntent.putExtra(TO_MAIN, returnContent);
				setResult(RESULT_OK, returnIntent);
				finish();
				}
			if(requestCode == ADD_NEW_CATEGORY){
				/* Returning from child activity NewSavedPhraseActivity*/
				String newCategory = data.getStringExtra(NewSavedPhraseActivity.NEW_CONTENT);
				int position = categoryList.size();
				addCategory(newCategory, (position -1));
				StringBuilder toSDCard = new StringBuilder(); 
				toSDCard.append(position-1);
				toSDCard.append("_");
				toSDCard.append(newCategory);
				saver.writeToSDFile(toSDCard.toString(), "SavedPhrases.txt");
				adapter.notifyDataSetChanged();
			}
		}
		
     }
	/* Add new categories*/ 
	public void addCategory(String categoryName, int position){
		categoryList.add((position), categoryName);
		contentLists.add((position), new ArrayList<String>());
		contentLists.get(position).add("Add new content");
	}
	/* Add new content to categories */
	public void addContent(String content, ArrayList<String> array){
		int size = array.size();
		array.add((size-1), content);
	}
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.saved_categories, menu);
		return true;
	}
	
	public int findSizeOfArray(){
		int size = categoryList.size();
		return size; 
		
	}
}
