package com.app.portabledeviceapplication;

import java.util.ArrayList;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;

public class SavedCategoryContentActivity extends Activity {
	ArrayList<String> contentList = new ArrayList<String>();
	ArrayAdapter<String> adapter;
	ListView listView;
	
	String currentCategoryTitle; 
	int currentCategoryPosition;
	boolean addedContent; 
	String newContent;
	Context context = SavedCategoryContentActivity.this; 
	
	//Identifier for content that are going to be sent between activities
	public final static String EXTRA_CONTENT = "com.app.portabledeviceapplication.CONTENT";
	public final static String ADDED_CONTENT_VALUE= "com.app.portabledeviceapplication.ADDED_VALUE";
	public final static String ADDED_CONTENT_BOOL = "com.app.portabledeviceapplication.ADDED_BOOL";
	public final static String CATEGORY_POSITION = "com.app.portabledeviceapplication.CATEGORY_POSITION";
	
	//Request code for startActivityForRestult
	private static final int ADD_NEW_CATEGORY = 0;
	/**
	 * onCreate is in all activities. Will always run when starting the activity
	 */
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_saved_category_content);
		
		addedContent = false; 
		/* Get data from parent activity */
		Intent intent = getIntent();
		contentList = intent.getStringArrayListExtra(SavedCategoriesActivity.EXTRA_ARRAY);
		currentCategoryTitle = intent.getStringExtra(SavedCategoriesActivity.CATEGORY_NAME);
		currentCategoryPosition = intent.getIntExtra(SavedCategoriesActivity.CURRENT_ARRAY_POSITION, 10000000);
		
		this.setTitle(currentCategoryTitle);
		
		adapter = new ArrayAdapter<String>(context, R.layout.saved_row_layout, contentList);
		listView = (ListView)findViewById(R.id.saved_category_content);
		listView.setAdapter(adapter);
		
		
		listView.setOnItemClickListener(new OnItemClickListener(){
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id){
				int size = findSizeOfArray();
				if(!(position == (size-1))){
					String content = contentList.get(position);
					Intent intent = new Intent(context, SavedCategoriesActivity.class);
					intent.putExtra(EXTRA_CONTENT, content);
					if(addedContent){
						intent.putExtra(ADDED_CONTENT_VALUE, newContent);
						intent.putExtra(ADDED_CONTENT_BOOL, addedContent);
						intent.putExtra(CATEGORY_POSITION, currentCategoryPosition); 
					}
					setResult(RESULT_OK, intent);
					finish();
				}
			}
		});
		listView.setOnItemLongClickListener(new OnItemLongClickListener(){
			public boolean onItemLongClick(AdapterView<?> parent, View view, int position, long id) {
				int size = findSizeOfArray();
				if(position == (size-1)){
					Intent intent = new Intent(context, NewSavedPhraseActivity.class);; 
					startActivityForResult(intent, ADD_NEW_CATEGORY);
				}
				return true;
            }
		});
	}
	
	/**
	 * When returning from a child-activity this function will be triggered
	 */
	public void onActivityResult(int requestCode, int resultCode, Intent data){
		super.onActivityResult(requestCode, resultCode, data);
		switch(resultCode){
		case(RESULT_OK):{
			switch(requestCode){
			case(ADD_NEW_CATEGORY):{
				newContent = data.getStringExtra(NewSavedPhraseActivity.NEW_CONTENT);
				int position = contentList.size(); 
				addContent(newContent, (position -1));
				addedContent = true; 
				adapter.notifyDataSetChanged();
				}
			}
			}
		}
     }

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.saved_category_content, menu);
		return true;
	}
	/**
	 * Adding content to contentList
	 * @param content
	 * @param position
	 */
	public void addContent(String content, int position){
		contentList.add(position, content);
	}
	public int findSizeOfArray(){
		int size = contentList.size();
		return size; 
		
	}


}
